{
  Haar Wavelet v.0.6

  (C)2K+1 by CARSTEN WAECHTER aka THE TOXIC AVENGER/AINC.

  This Unit/Prog is Public Domain..
   Feel free to use, enhance or even learn about this code..
  If you like it, please drop a message to:
   toxie@ainc.de
  To get the newest version of Haar Wavelet surf to:
   http://ainc.de

  All future changes will be listed below..
}

//Compile it using the DCC32-Compiler delivered with Delphi

{$D-,L-}
{$APPTYPE GUI}
USES Windows,Messages,Wave;

Var
  hWindow     : HWnd;                  {Window handle}
  hHDC        : HDC;                   {Draw Context}
  pbitmapinfo : pointer;
  AMessage    : TMsg;

  hwl_head    : HWL_Header;
  vidvscr     : pointer;               {Virtual screen}
  xres,yres   : longint;


PROCEDURE InitGraphic;
 Var bisize : longint;
BEGIN
  bisize:=sizeof(TBITMAPINFOHEADER);
  getmem(pbitmapinfo, bisize);
  fillchar(pbitmapinfo^, bisize, 0);

  with TBITMAPINFO(pbitmapinfo^) do
   begin {BitmapInfoHeader 32Bit}
     bmiHeader.biSize        :=bisize;
     bmiHeader.biWidth       :=xres;
     bmiHeader.biHeight      :=-yres;
     bmiHeader.biPlanes      :=1;
     bmiHeader.biBitCount    :=32;
     bmiHeader.biCompression :=BI_RGB;
   end;
END;


PROCEDURE BlitGraphic(source : pointer);
 Var r: trect;
BEGIN
  if (hHDC=0) then exit;

  GetClientRect(hWindow, r);
  StretchDIBits(hHDC, 0, 0, r.right, r.bottom, 0, 0,
                xres, yres, source, tbitmapinfo(pbitmapinfo^),
                DIB_RGB_COLORS, SRCCOPY);
END;


FUNCTION WindowProc(Window: HWnd; AMessage, WParam, LParam: Longint): Longint; stdcall; export;
BEGIN
  WindowProc:=0;

  case AMessage of
    wm_paint: begin
                BlitGraphic(vidvscr);
                Exit;
    end;
    wm_Destroy: begin   { Closed ??!}
                  ReleaseDC(hWindow,hHDC);
                  hHDC:=0;
                  PostQuitMessage(0);
                  Exit;
    end;
  end;

  WindowProc:=DefWindowProc(Window, AMessage, WParam, LParam);
END;


FUNCTION WinRegister: Boolean; {Register Window Class}
Var WindowClass: TWndClass;
BEGIN
  WindowClass.Style:=cs_ByteAlignClient;
  WindowClass.lpfnWndProc:=@WindowProc;
  WindowClass.cbClsExtra:=0;
  WindowClass.cbWndExtra:=0;
  WindowClass.hInstance:=system.MainInstance;
  WindowClass.hIcon:=LoadIcon(0, idi_Application);
  WindowClass.hCursor:=LoadCursor(0, idc_Arrow);
  WindowClass.hbrBackground:=GetStockObject(BLACK_BRUSH);
  WindowClass.lpszMenuName:=nil;
  WindowClass.lpszClassName:='AINC'; {Class Name}

  WinRegister:=RegisterClass(WindowClass)<>0;
END;


FUNCTION WinCreate: HWnd;  {Create Window Class}
Var
  hWindow: HWnd;
  r: trect;
  style, styleex : longint;
BEGIN
  r.top   :=CW_USEDEFAULT;
  r.left  :=CW_USEDEFAULT;
  r.right :=xres+2*GetSystemMetrics(SM_CXSIZEFRAME);
  r.bottom:=yres+GetSystemMetrics(SM_CYCAPTION)-GetSystemMetrics(SM_CYBORDER)+2*GetSystemMetrics(SM_CYSIZEFRAME);

  style:=WS_OVERLAPPED or WS_MINIMIZEBOX or WS_SYSMENU or WS_SIZEBOX or WS_MAXIMIZEBOX;
  styleex:=0;

  hWindow:=CreateWindowEx(styleex, 'AINC', 'Wavelet', style, r.left, r.top, r.right, r.bottom, 0, 0, system.MainInstance, nil);
                                   {Class} {Window Name}
  if hWindow<>0 then
   begin
     ShowWindow(hWindow, CmdShow);
     UpdateWindow(hWindow);
     hHDC:=GetDC(hWindow);
   end;

  WinCreate:=hWindow;
END;

begin
  HWL2Mem(vidvscr,hwl_head,'hwltest.hwl',true); //Load the file into the pointer 'vidvscr', alloc mem for it and deliver all infos in 'hwl_head'

  //That's it.. =)

  xres:=hwl_head.width;  //Used for Window-Setup
  yres:=hwl_head.height;

  //The Rest is just Windows-Stuff to display the 32Bit-RGB-Content of 'vidvscr'

  if not WinRegister then
   begin
     MessageBox(0, 'Register Window Class failed', nil, mb_Ok);
     Halt(6);
   end;

  hWindow:=WinCreate;
  if (longint(hWindow)=0) then
   begin
     MessageBox(0, 'Window Create failed', nil, mb_Ok);
     Halt(6);
   end;

  InitGraphic;

  while GetMessage(AMessage,0,0,0) do  {Shows the image until a key is pressed}
   begin
     sleep(50);
     TranslateMessage(AMessage);
     DispatchMessage(AMessage);
   end;
end.